class
	PD_BRANCH_CHAIN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_BRANCH_CHAIN]} outer.make
			create {CE_NATURAL_8_POINTER} current_branch.make
		end

	make_initialized (a_data: TUPLE [
				a_outer: CE_POINTER [PD_BRANCH_CHAIN]
				a_current_branch: CE_POINTER [NATURAL_8]
			])
		do
			outer := a_data.a_outer
			current_branch := a_data.a_current_branch
		end

feature {ANY} -- fields

	outer: CE_POINTER [PD_BRANCH_CHAIN] assign set__outer

	current_branch: CE_POINTER [NATURAL_8] assign set__current_branch

feature {ANY} -- field setters

	set__outer (a_outer: CE_POINTER [PD_BRANCH_CHAIN])
		do
			outer := a_outer
			update_memory_field ("outer")
		end

	set__current_branch (a_current_branch: CE_POINTER [NATURAL_8])
		do
			current_branch := a_current_branch
			update_memory_field ("current_branch")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			outer := a_other.outer
			current_branch := a_other.current_branch
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				outer.is_equal (a_other.outer) and
				current_branch.is_equal (a_other.current_branch)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("outer"),
					create {CE_STRUCTURE_FIELD}.make ("current_branch")
				>>)
			init_structure_info
		end

end
