class
	PD_DFA_MATCH_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} start_code.make
			create {CE_NATURAL_8_POINTER} start_subject.make
			create {CE_NATURAL_8_POINTER} end_subject.make
			create {CE_NATURAL_8_POINTER} start_used_ptr.make
			create {CE_NATURAL_8_POINTER} tables.make
			create {CE_NATURAL_8_ARRAY} nl.make (<<4>>)
			create {CE_VOID_POINTER} callout_data.make
			create {CE_CLASS_POINTER [PD_DFA_RECURSION_INFO]} recursive.make
		end

	make_initialized (a_data: TUPLE [
				a_start_code: CE_POINTER [NATURAL_8]
				a_start_subject: CE_POINTER [NATURAL_8]
				a_end_subject: CE_POINTER [NATURAL_8]
				a_start_used_ptr: CE_POINTER [NATURAL_8]
				a_tables: CE_POINTER [NATURAL_8]
				a_start_offset: INTEGER_32
				a_moptions: INTEGER_32
				a_poptions: INTEGER_32
				a_nltype: INTEGER_32
				a_nllen: INTEGER_32
				a_nl: CE_ARRAY [NATURAL_8]
				a_callout_data: CE_POINTER [ANY]
				a_recursive: CE_POINTER [PD_DFA_RECURSION_INFO]
			])
		do
			start_code := a_data.a_start_code
			start_subject := a_data.a_start_subject
			end_subject := a_data.a_end_subject
			start_used_ptr := a_data.a_start_used_ptr
			tables := a_data.a_tables
			start_offset := a_data.a_start_offset
			moptions := a_data.a_moptions
			poptions := a_data.a_poptions
			nltype := a_data.a_nltype
			nllen := a_data.a_nllen
			nl := a_data.a_nl
			callout_data := a_data.a_callout_data
			recursive := a_data.a_recursive
		end

feature {ANY} -- fields

	start_code: CE_POINTER [NATURAL_8] assign set__start_code

	start_subject: CE_POINTER [NATURAL_8] assign set__start_subject

	end_subject: CE_POINTER [NATURAL_8] assign set__end_subject

	start_used_ptr: CE_POINTER [NATURAL_8] assign set__start_used_ptr

	tables: CE_POINTER [NATURAL_8] assign set__tables

	start_offset: INTEGER_32 assign set__start_offset

	moptions: INTEGER_32 assign set__moptions

	poptions: INTEGER_32 assign set__poptions

	nltype: INTEGER_32 assign set__nltype

	nllen: INTEGER_32 assign set__nllen

	nl: CE_ARRAY [NATURAL_8]

	callout_data: CE_POINTER [ANY] assign set__callout_data

	recursive: CE_POINTER [PD_DFA_RECURSION_INFO] assign set__recursive

feature {ANY} -- field setters

	set__start_code (a_start_code: CE_POINTER [NATURAL_8])
		do
			start_code := a_start_code
			update_memory_field ("start_code")
		end

	set__start_subject (a_start_subject: CE_POINTER [NATURAL_8])
		do
			start_subject := a_start_subject
			update_memory_field ("start_subject")
		end

	set__end_subject (a_end_subject: CE_POINTER [NATURAL_8])
		do
			end_subject := a_end_subject
			update_memory_field ("end_subject")
		end

	set__start_used_ptr (a_start_used_ptr: CE_POINTER [NATURAL_8])
		do
			start_used_ptr := a_start_used_ptr
			update_memory_field ("start_used_ptr")
		end

	set__tables (a_tables: CE_POINTER [NATURAL_8])
		do
			tables := a_tables
			update_memory_field ("tables")
		end

	set__start_offset (a_start_offset: INTEGER_32)
		do
			start_offset := a_start_offset
			update_memory_field ("start_offset")
		end

	set__moptions (a_moptions: INTEGER_32)
		do
			moptions := a_moptions
			update_memory_field ("moptions")
		end

	set__poptions (a_poptions: INTEGER_32)
		do
			poptions := a_poptions
			update_memory_field ("poptions")
		end

	set__nltype (a_nltype: INTEGER_32)
		do
			nltype := a_nltype
			update_memory_field ("nltype")
		end

	set__nllen (a_nllen: INTEGER_32)
		do
			nllen := a_nllen
			update_memory_field ("nllen")
		end

	set__callout_data (a_callout_data: CE_POINTER [ANY])
		do
			callout_data := a_callout_data
			update_memory_field ("callout_data")
		end

	set__recursive (a_recursive: CE_POINTER [PD_DFA_RECURSION_INFO])
		do
			recursive := a_recursive
			update_memory_field ("recursive")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			start_code := a_other.start_code
			start_subject := a_other.start_subject
			end_subject := a_other.end_subject
			start_used_ptr := a_other.start_used_ptr
			tables := a_other.tables
			start_offset := a_other.start_offset
			moptions := a_other.moptions
			poptions := a_other.poptions
			nltype := a_other.nltype
			nllen := a_other.nllen
			nl := a_other.nl.twin
			callout_data := a_other.callout_data
			recursive := a_other.recursive
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				start_code.is_equal (a_other.start_code) and
				start_subject.is_equal (a_other.start_subject) and
				end_subject.is_equal (a_other.end_subject) and
				start_used_ptr.is_equal (a_other.start_used_ptr) and
				tables.is_equal (a_other.tables) and
				start_offset = a_other.start_offset and
				moptions = a_other.moptions and
				poptions = a_other.poptions and
				nltype = a_other.nltype and
				nllen = a_other.nllen and
				nl.is_equal (a_other.nl) and
				callout_data.is_equal (a_other.callout_data) and
				recursive.is_equal (a_other.recursive)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("start_code"),
					create {CE_STRUCTURE_FIELD}.make ("start_subject"),
					create {CE_STRUCTURE_FIELD}.make ("end_subject"),
					create {CE_STRUCTURE_FIELD}.make ("start_used_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("tables"),
					create {CE_STRUCTURE_FIELD}.make ("start_offset"),
					create {CE_STRUCTURE_FIELD}.make ("moptions"),
					create {CE_STRUCTURE_FIELD}.make ("poptions"),
					create {CE_STRUCTURE_FIELD}.make ("nltype"),
					create {CE_STRUCTURE_FIELD}.make ("nllen"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("nl", <<4>>),
					create {CE_STRUCTURE_FIELD}.make ("callout_data"),
					create {CE_STRUCTURE_FIELD}.make ("recursive")
				>>)
			init_structure_info
		end

end
