class
	PD_MATCH_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_32_POINTER} offset_vector.make
			create {CE_NATURAL_8_POINTER} name_table.make
			create {CE_NATURAL_8_ARRAY} nl.make (<<4>>)
			create {CE_NATURAL_8_POINTER} lcc.make
			create {CE_NATURAL_8_POINTER} fcc.make
			create {CE_NATURAL_8_POINTER} ctypes.make
			create {CE_NATURAL_8_POINTER} start_code.make
			create {CE_NATURAL_8_POINTER} start_subject.make
			create {CE_NATURAL_8_POINTER} end_subject.make
			create {CE_NATURAL_8_POINTER} start_match_ptr.make
			create {CE_NATURAL_8_POINTER} end_match_ptr.make
			create {CE_NATURAL_8_POINTER} start_used_ptr.make
			create {CE_CLASS_POINTER [PD_EPTRBLOCK]} eptrchain.make
			create {CE_CLASS_POINTER [PD_RECURSION_INFO]} recursive.make
			create {CE_VOID_POINTER} callout_data.make
			create {CE_NATURAL_8_POINTER} mark.make
			create {CE_NATURAL_8_POINTER} nomatch_mark.make
			create {CE_NATURAL_8_POINTER} once_target.make
		end

	make_initialized (a_data: TUPLE [
				a_match_call_count: NATURAL_32
				a_match_limit: NATURAL_32
				a_match_limit_recursion: NATURAL_32
				a_offset_vector: CE_POINTER [INTEGER_32]
				a_offset_end: INTEGER_32
				a_offset_max: INTEGER_32
				a_nltype: INTEGER_32
				a_nllen: INTEGER_32
				a_name_count: INTEGER_32
				a_name_entry_size: INTEGER_32
				a_name_table: CE_POINTER [NATURAL_8]
				a_nl: CE_ARRAY [NATURAL_8]
				a_lcc: CE_POINTER [NATURAL_8]
				a_fcc: CE_POINTER [NATURAL_8]
				a_ctypes: CE_POINTER [NATURAL_8]
				a_offset_overflow: INTEGER_32
				a_notbol: INTEGER_32
				a_noteol: INTEGER_32
				a_utf: INTEGER_32
				a_jscript_compat: INTEGER_32
				a_use_ucp: INTEGER_32
				a_endonly: INTEGER_32
				a_notempty: INTEGER_32
				a_notempty_atstart: INTEGER_32
				a_hitend: INTEGER_32
				a_bsr_anycrlf: INTEGER_32
				a_hasthen: INTEGER_32
				a_ignore_skip_arg: INTEGER_32
				a_start_code: CE_POINTER [NATURAL_8]
				a_start_subject: CE_POINTER [NATURAL_8]
				a_end_subject: CE_POINTER [NATURAL_8]
				a_start_match_ptr: CE_POINTER [NATURAL_8]
				a_end_match_ptr: CE_POINTER [NATURAL_8]
				a_start_used_ptr: CE_POINTER [NATURAL_8]
				a_partial: INTEGER_32
				a_end_offset_top: INTEGER_32
				a_capture_last: INTEGER_32
				a_start_offset: INTEGER_32
				a_match_function_type: INTEGER_32
				a_eptrchain: CE_POINTER [PD_EPTRBLOCK]
				a_eptrn: INTEGER_32
				a_recursive: CE_POINTER [PD_RECURSION_INFO]
				a_callout_data: CE_POINTER [ANY]
				a_mark: CE_POINTER [NATURAL_8]
				a_nomatch_mark: CE_POINTER [NATURAL_8]
				a_once_target: CE_POINTER [NATURAL_8]
			])
		do
			match_call_count := a_data.a_match_call_count
			match_limit := a_data.a_match_limit
			match_limit_recursion := a_data.a_match_limit_recursion
			offset_vector := a_data.a_offset_vector
			offset_end := a_data.a_offset_end
			offset_max := a_data.a_offset_max
			nltype := a_data.a_nltype
			nllen := a_data.a_nllen
			name_count := a_data.a_name_count
			name_entry_size := a_data.a_name_entry_size
			name_table := a_data.a_name_table
			nl := a_data.a_nl
			lcc := a_data.a_lcc
			fcc := a_data.a_fcc
			ctypes := a_data.a_ctypes
			offset_overflow := a_data.a_offset_overflow
			notbol := a_data.a_notbol
			noteol := a_data.a_noteol
			utf := a_data.a_utf
			jscript_compat := a_data.a_jscript_compat
			use_ucp := a_data.a_use_ucp
			endonly := a_data.a_endonly
			notempty := a_data.a_notempty
			notempty_atstart := a_data.a_notempty_atstart
			hitend := a_data.a_hitend
			bsr_anycrlf := a_data.a_bsr_anycrlf
			hasthen := a_data.a_hasthen
			ignore_skip_arg := a_data.a_ignore_skip_arg
			start_code := a_data.a_start_code
			start_subject := a_data.a_start_subject
			end_subject := a_data.a_end_subject
			start_match_ptr := a_data.a_start_match_ptr
			end_match_ptr := a_data.a_end_match_ptr
			start_used_ptr := a_data.a_start_used_ptr
			partial := a_data.a_partial
			end_offset_top := a_data.a_end_offset_top
			capture_last := a_data.a_capture_last
			start_offset := a_data.a_start_offset
			match_function_type := a_data.a_match_function_type
			eptrchain := a_data.a_eptrchain
			eptrn := a_data.a_eptrn
			recursive := a_data.a_recursive
			callout_data := a_data.a_callout_data
			mark := a_data.a_mark
			nomatch_mark := a_data.a_nomatch_mark
			once_target := a_data.a_once_target
		end

feature {ANY} -- fields

	match_call_count: NATURAL_32 assign set__match_call_count

	match_limit: NATURAL_32 assign set__match_limit

	match_limit_recursion: NATURAL_32 assign set__match_limit_recursion

	offset_vector: CE_POINTER [INTEGER_32] assign set__offset_vector

	offset_end: INTEGER_32 assign set__offset_end

	offset_max: INTEGER_32 assign set__offset_max

	nltype: INTEGER_32 assign set__nltype

	nllen: INTEGER_32 assign set__nllen

	name_count: INTEGER_32 assign set__name_count

	name_entry_size: INTEGER_32 assign set__name_entry_size

	name_table: CE_POINTER [NATURAL_8] assign set__name_table

	nl: CE_ARRAY [NATURAL_8]

	lcc: CE_POINTER [NATURAL_8] assign set__lcc

	fcc: CE_POINTER [NATURAL_8] assign set__fcc

	ctypes: CE_POINTER [NATURAL_8] assign set__ctypes

	offset_overflow: INTEGER_32 assign set__offset_overflow

	notbol: INTEGER_32 assign set__notbol

	noteol: INTEGER_32 assign set__noteol

	utf: INTEGER_32 assign set__utf

	jscript_compat: INTEGER_32 assign set__jscript_compat

	use_ucp: INTEGER_32 assign set__use_ucp

	endonly: INTEGER_32 assign set__endonly

	notempty: INTEGER_32 assign set__notempty

	notempty_atstart: INTEGER_32 assign set__notempty_atstart

	hitend: INTEGER_32 assign set__hitend

	bsr_anycrlf: INTEGER_32 assign set__bsr_anycrlf

	hasthen: INTEGER_32 assign set__hasthen

	ignore_skip_arg: INTEGER_32 assign set__ignore_skip_arg

	start_code: CE_POINTER [NATURAL_8] assign set__start_code

	start_subject: CE_POINTER [NATURAL_8] assign set__start_subject

	end_subject: CE_POINTER [NATURAL_8] assign set__end_subject

	start_match_ptr: CE_POINTER [NATURAL_8] assign set__start_match_ptr

	end_match_ptr: CE_POINTER [NATURAL_8] assign set__end_match_ptr

	start_used_ptr: CE_POINTER [NATURAL_8] assign set__start_used_ptr

	partial: INTEGER_32 assign set__partial

	end_offset_top: INTEGER_32 assign set__end_offset_top

	capture_last: INTEGER_32 assign set__capture_last

	start_offset: INTEGER_32 assign set__start_offset

	match_function_type: INTEGER_32 assign set__match_function_type

	eptrchain: CE_POINTER [PD_EPTRBLOCK] assign set__eptrchain

	eptrn: INTEGER_32 assign set__eptrn

	recursive: CE_POINTER [PD_RECURSION_INFO] assign set__recursive

	callout_data: CE_POINTER [ANY] assign set__callout_data

	mark: CE_POINTER [NATURAL_8] assign set__mark

	nomatch_mark: CE_POINTER [NATURAL_8] assign set__nomatch_mark

	once_target: CE_POINTER [NATURAL_8] assign set__once_target

feature {ANY} -- field setters

	set__match_call_count (a_match_call_count: NATURAL_32)
		do
			match_call_count := a_match_call_count
			update_memory_field ("match_call_count")
		end

	set__match_limit (a_match_limit: NATURAL_32)
		do
			match_limit := a_match_limit
			update_memory_field ("match_limit")
		end

	set__match_limit_recursion (a_match_limit_recursion: NATURAL_32)
		do
			match_limit_recursion := a_match_limit_recursion
			update_memory_field ("match_limit_recursion")
		end

	set__offset_vector (a_offset_vector: CE_POINTER [INTEGER_32])
		do
			offset_vector := a_offset_vector
			update_memory_field ("offset_vector")
		end

	set__offset_end (a_offset_end: INTEGER_32)
		do
			offset_end := a_offset_end
			update_memory_field ("offset_end")
		end

	set__offset_max (a_offset_max: INTEGER_32)
		do
			offset_max := a_offset_max
			update_memory_field ("offset_max")
		end

	set__nltype (a_nltype: INTEGER_32)
		do
			nltype := a_nltype
			update_memory_field ("nltype")
		end

	set__nllen (a_nllen: INTEGER_32)
		do
			nllen := a_nllen
			update_memory_field ("nllen")
		end

	set__name_count (a_name_count: INTEGER_32)
		do
			name_count := a_name_count
			update_memory_field ("name_count")
		end

	set__name_entry_size (a_name_entry_size: INTEGER_32)
		do
			name_entry_size := a_name_entry_size
			update_memory_field ("name_entry_size")
		end

	set__name_table (a_name_table: CE_POINTER [NATURAL_8])
		do
			name_table := a_name_table
			update_memory_field ("name_table")
		end

	set__lcc (a_lcc: CE_POINTER [NATURAL_8])
		do
			lcc := a_lcc
			update_memory_field ("lcc")
		end

	set__fcc (a_fcc: CE_POINTER [NATURAL_8])
		do
			fcc := a_fcc
			update_memory_field ("fcc")
		end

	set__ctypes (a_ctypes: CE_POINTER [NATURAL_8])
		do
			ctypes := a_ctypes
			update_memory_field ("ctypes")
		end

	set__offset_overflow (a_offset_overflow: INTEGER_32)
		do
			offset_overflow := a_offset_overflow
			update_memory_field ("offset_overflow")
		end

	set__notbol (a_notbol: INTEGER_32)
		do
			notbol := a_notbol
			update_memory_field ("notbol")
		end

	set__noteol (a_noteol: INTEGER_32)
		do
			noteol := a_noteol
			update_memory_field ("noteol")
		end

	set__utf (a_utf: INTEGER_32)
		do
			utf := a_utf
			update_memory_field ("utf")
		end

	set__jscript_compat (a_jscript_compat: INTEGER_32)
		do
			jscript_compat := a_jscript_compat
			update_memory_field ("jscript_compat")
		end

	set__use_ucp (a_use_ucp: INTEGER_32)
		do
			use_ucp := a_use_ucp
			update_memory_field ("use_ucp")
		end

	set__endonly (a_endonly: INTEGER_32)
		do
			endonly := a_endonly
			update_memory_field ("endonly")
		end

	set__notempty (a_notempty: INTEGER_32)
		do
			notempty := a_notempty
			update_memory_field ("notempty")
		end

	set__notempty_atstart (a_notempty_atstart: INTEGER_32)
		do
			notempty_atstart := a_notempty_atstart
			update_memory_field ("notempty_atstart")
		end

	set__hitend (a_hitend: INTEGER_32)
		do
			hitend := a_hitend
			update_memory_field ("hitend")
		end

	set__bsr_anycrlf (a_bsr_anycrlf: INTEGER_32)
		do
			bsr_anycrlf := a_bsr_anycrlf
			update_memory_field ("bsr_anycrlf")
		end

	set__hasthen (a_hasthen: INTEGER_32)
		do
			hasthen := a_hasthen
			update_memory_field ("hasthen")
		end

	set__ignore_skip_arg (a_ignore_skip_arg: INTEGER_32)
		do
			ignore_skip_arg := a_ignore_skip_arg
			update_memory_field ("ignore_skip_arg")
		end

	set__start_code (a_start_code: CE_POINTER [NATURAL_8])
		do
			start_code := a_start_code
			update_memory_field ("start_code")
		end

	set__start_subject (a_start_subject: CE_POINTER [NATURAL_8])
		do
			start_subject := a_start_subject
			update_memory_field ("start_subject")
		end

	set__end_subject (a_end_subject: CE_POINTER [NATURAL_8])
		do
			end_subject := a_end_subject
			update_memory_field ("end_subject")
		end

	set__start_match_ptr (a_start_match_ptr: CE_POINTER [NATURAL_8])
		do
			start_match_ptr := a_start_match_ptr
			update_memory_field ("start_match_ptr")
		end

	set__end_match_ptr (a_end_match_ptr: CE_POINTER [NATURAL_8])
		do
			end_match_ptr := a_end_match_ptr
			update_memory_field ("end_match_ptr")
		end

	set__start_used_ptr (a_start_used_ptr: CE_POINTER [NATURAL_8])
		do
			start_used_ptr := a_start_used_ptr
			update_memory_field ("start_used_ptr")
		end

	set__partial (a_partial: INTEGER_32)
		do
			partial := a_partial
			update_memory_field ("partial")
		end

	set__end_offset_top (a_end_offset_top: INTEGER_32)
		do
			end_offset_top := a_end_offset_top
			update_memory_field ("end_offset_top")
		end

	set__capture_last (a_capture_last: INTEGER_32)
		do
			capture_last := a_capture_last
			update_memory_field ("capture_last")
		end

	set__start_offset (a_start_offset: INTEGER_32)
		do
			start_offset := a_start_offset
			update_memory_field ("start_offset")
		end

	set__match_function_type (a_match_function_type: INTEGER_32)
		do
			match_function_type := a_match_function_type
			update_memory_field ("match_function_type")
		end

	set__eptrchain (a_eptrchain: CE_POINTER [PD_EPTRBLOCK])
		do
			eptrchain := a_eptrchain
			update_memory_field ("eptrchain")
		end

	set__eptrn (a_eptrn: INTEGER_32)
		do
			eptrn := a_eptrn
			update_memory_field ("eptrn")
		end

	set__recursive (a_recursive: CE_POINTER [PD_RECURSION_INFO])
		do
			recursive := a_recursive
			update_memory_field ("recursive")
		end

	set__callout_data (a_callout_data: CE_POINTER [ANY])
		do
			callout_data := a_callout_data
			update_memory_field ("callout_data")
		end

	set__mark (a_mark: CE_POINTER [NATURAL_8])
		do
			mark := a_mark
			update_memory_field ("mark")
		end

	set__nomatch_mark (a_nomatch_mark: CE_POINTER [NATURAL_8])
		do
			nomatch_mark := a_nomatch_mark
			update_memory_field ("nomatch_mark")
		end

	set__once_target (a_once_target: CE_POINTER [NATURAL_8])
		do
			once_target := a_once_target
			update_memory_field ("once_target")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			match_call_count := a_other.match_call_count
			match_limit := a_other.match_limit
			match_limit_recursion := a_other.match_limit_recursion
			offset_vector := a_other.offset_vector
			offset_end := a_other.offset_end
			offset_max := a_other.offset_max
			nltype := a_other.nltype
			nllen := a_other.nllen
			name_count := a_other.name_count
			name_entry_size := a_other.name_entry_size
			name_table := a_other.name_table
			nl := a_other.nl.twin
			lcc := a_other.lcc
			fcc := a_other.fcc
			ctypes := a_other.ctypes
			offset_overflow := a_other.offset_overflow
			notbol := a_other.notbol
			noteol := a_other.noteol
			utf := a_other.utf
			jscript_compat := a_other.jscript_compat
			use_ucp := a_other.use_ucp
			endonly := a_other.endonly
			notempty := a_other.notempty
			notempty_atstart := a_other.notempty_atstart
			hitend := a_other.hitend
			bsr_anycrlf := a_other.bsr_anycrlf
			hasthen := a_other.hasthen
			ignore_skip_arg := a_other.ignore_skip_arg
			start_code := a_other.start_code
			start_subject := a_other.start_subject
			end_subject := a_other.end_subject
			start_match_ptr := a_other.start_match_ptr
			end_match_ptr := a_other.end_match_ptr
			start_used_ptr := a_other.start_used_ptr
			partial := a_other.partial
			end_offset_top := a_other.end_offset_top
			capture_last := a_other.capture_last
			start_offset := a_other.start_offset
			match_function_type := a_other.match_function_type
			eptrchain := a_other.eptrchain
			eptrn := a_other.eptrn
			recursive := a_other.recursive
			callout_data := a_other.callout_data
			mark := a_other.mark
			nomatch_mark := a_other.nomatch_mark
			once_target := a_other.once_target
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				match_call_count = a_other.match_call_count and
				match_limit = a_other.match_limit and
				match_limit_recursion = a_other.match_limit_recursion and
				offset_vector.is_equal (a_other.offset_vector) and
				offset_end = a_other.offset_end and
				offset_max = a_other.offset_max and
				nltype = a_other.nltype and
				nllen = a_other.nllen and
				name_count = a_other.name_count and
				name_entry_size = a_other.name_entry_size and
				name_table.is_equal (a_other.name_table) and
				nl.is_equal (a_other.nl) and
				lcc.is_equal (a_other.lcc) and
				fcc.is_equal (a_other.fcc) and
				ctypes.is_equal (a_other.ctypes) and
				offset_overflow = a_other.offset_overflow and
				notbol = a_other.notbol and
				noteol = a_other.noteol and
				utf = a_other.utf and
				jscript_compat = a_other.jscript_compat and
				use_ucp = a_other.use_ucp and
				endonly = a_other.endonly and
				notempty = a_other.notempty and
				notempty_atstart = a_other.notempty_atstart and
				hitend = a_other.hitend and
				bsr_anycrlf = a_other.bsr_anycrlf and
				hasthen = a_other.hasthen and
				ignore_skip_arg = a_other.ignore_skip_arg and
				start_code.is_equal (a_other.start_code) and
				start_subject.is_equal (a_other.start_subject) and
				end_subject.is_equal (a_other.end_subject) and
				start_match_ptr.is_equal (a_other.start_match_ptr) and
				end_match_ptr.is_equal (a_other.end_match_ptr) and
				start_used_ptr.is_equal (a_other.start_used_ptr) and
				partial = a_other.partial and
				end_offset_top = a_other.end_offset_top and
				capture_last = a_other.capture_last and
				start_offset = a_other.start_offset and
				match_function_type = a_other.match_function_type and
				eptrchain.is_equal (a_other.eptrchain) and
				eptrn = a_other.eptrn and
				recursive.is_equal (a_other.recursive) and
				callout_data.is_equal (a_other.callout_data) and
				mark.is_equal (a_other.mark) and
				nomatch_mark.is_equal (a_other.nomatch_mark) and
				once_target.is_equal (a_other.once_target)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("match_call_count"),
					create {CE_STRUCTURE_FIELD}.make ("match_limit"),
					create {CE_STRUCTURE_FIELD}.make ("match_limit_recursion"),
					create {CE_STRUCTURE_FIELD}.make ("offset_vector"),
					create {CE_STRUCTURE_FIELD}.make ("offset_end"),
					create {CE_STRUCTURE_FIELD}.make ("offset_max"),
					create {CE_STRUCTURE_FIELD}.make ("nltype"),
					create {CE_STRUCTURE_FIELD}.make ("nllen"),
					create {CE_STRUCTURE_FIELD}.make ("name_count"),
					create {CE_STRUCTURE_FIELD}.make ("name_entry_size"),
					create {CE_STRUCTURE_FIELD}.make ("name_table"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("nl", <<4>>),
					create {CE_STRUCTURE_FIELD}.make ("lcc"),
					create {CE_STRUCTURE_FIELD}.make ("fcc"),
					create {CE_STRUCTURE_FIELD}.make ("ctypes"),
					create {CE_STRUCTURE_FIELD}.make ("offset_overflow"),
					create {CE_STRUCTURE_FIELD}.make ("notbol"),
					create {CE_STRUCTURE_FIELD}.make ("noteol"),
					create {CE_STRUCTURE_FIELD}.make ("utf"),
					create {CE_STRUCTURE_FIELD}.make ("jscript_compat"),
					create {CE_STRUCTURE_FIELD}.make ("use_ucp"),
					create {CE_STRUCTURE_FIELD}.make ("endonly"),
					create {CE_STRUCTURE_FIELD}.make ("notempty"),
					create {CE_STRUCTURE_FIELD}.make ("notempty_atstart"),
					create {CE_STRUCTURE_FIELD}.make ("hitend"),
					create {CE_STRUCTURE_FIELD}.make ("bsr_anycrlf"),
					create {CE_STRUCTURE_FIELD}.make ("hasthen"),
					create {CE_STRUCTURE_FIELD}.make ("ignore_skip_arg"),
					create {CE_STRUCTURE_FIELD}.make ("start_code"),
					create {CE_STRUCTURE_FIELD}.make ("start_subject"),
					create {CE_STRUCTURE_FIELD}.make ("end_subject"),
					create {CE_STRUCTURE_FIELD}.make ("start_match_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("end_match_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("start_used_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("partial"),
					create {CE_STRUCTURE_FIELD}.make ("end_offset_top"),
					create {CE_STRUCTURE_FIELD}.make ("capture_last"),
					create {CE_STRUCTURE_FIELD}.make ("start_offset"),
					create {CE_STRUCTURE_FIELD}.make ("match_function_type"),
					create {CE_STRUCTURE_FIELD}.make ("eptrchain"),
					create {CE_STRUCTURE_FIELD}.make ("eptrn"),
					create {CE_STRUCTURE_FIELD}.make ("recursive"),
					create {CE_STRUCTURE_FIELD}.make ("callout_data"),
					create {CE_STRUCTURE_FIELD}.make ("mark"),
					create {CE_STRUCTURE_FIELD}.make ("nomatch_mark"),
					create {CE_STRUCTURE_FIELD}.make ("once_target")
				>>)
			init_structure_info
		end

end
