class
	PD_OPEN_CAPITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_OPEN_CAPITEM]} next.make
		end

	make_initialized (a_data: TUPLE [
				a_next: CE_POINTER [PD_OPEN_CAPITEM]
				a_number: NATURAL_16
				a_flag: NATURAL_16
			])
		do
			next := a_data.a_next
			number := a_data.a_number
			flag := a_data.a_flag
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_OPEN_CAPITEM] assign set__next

	number: NATURAL_16 assign set__number

	flag: NATURAL_16 assign set__flag

feature {ANY} -- field setters

	set__next (a_next: CE_POINTER [PD_OPEN_CAPITEM])
		do
			next := a_next
			update_memory_field ("next")
		end

	set__number (a_number: NATURAL_16)
		do
			number := a_number
			update_memory_field ("number")
		end

	set__flag (a_flag: NATURAL_16)
		do
			flag := a_flag
			update_memory_field ("flag")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			number := a_other.number
			flag := a_other.flag
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				number = a_other.number and
				flag = a_other.flag
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("number"),
					create {CE_STRUCTURE_FIELD}.make ("flag")
				>>)
			init_structure_info
		end

end
