class
	PD_PCRE_CALLOUT_BLOCK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_32_POINTER} offset_vector.make
			create {CE_INTEGER_8_POINTER} subject.make
			create {CE_VOID_POINTER} callout_data.make
			create {CE_NATURAL_8_POINTER} mark.make
		end

	make_initialized (a_data: TUPLE [
				a_version: INTEGER_32
				a_callout_number: INTEGER_32
				a_offset_vector: CE_POINTER [INTEGER_32]
				a_subject: CE_POINTER [INTEGER_8]
				a_subject_length: INTEGER_32
				a_start_match: INTEGER_32
				a_current_position: INTEGER_32
				a_capture_top: INTEGER_32
				a_capture_last: INTEGER_32
				a_callout_data: CE_POINTER [ANY]
				a_pattern_position: INTEGER_32
				a_next_item_length: INTEGER_32
				a_mark: CE_POINTER [NATURAL_8]
			])
		do
			version := a_data.a_version
			callout_number := a_data.a_callout_number
			offset_vector := a_data.a_offset_vector
			subject := a_data.a_subject
			subject_length := a_data.a_subject_length
			start_match := a_data.a_start_match
			current_position := a_data.a_current_position
			capture_top := a_data.a_capture_top
			capture_last := a_data.a_capture_last
			callout_data := a_data.a_callout_data
			pattern_position := a_data.a_pattern_position
			next_item_length := a_data.a_next_item_length
			mark := a_data.a_mark
		end

feature {ANY} -- fields

	version: INTEGER_32 assign set__version

	callout_number: INTEGER_32 assign set__callout_number

	offset_vector: CE_POINTER [INTEGER_32] assign set__offset_vector

	subject: CE_POINTER [INTEGER_8] assign set__subject

	subject_length: INTEGER_32 assign set__subject_length

	start_match: INTEGER_32 assign set__start_match

	current_position: INTEGER_32 assign set__current_position

	capture_top: INTEGER_32 assign set__capture_top

	capture_last: INTEGER_32 assign set__capture_last

	callout_data: CE_POINTER [ANY] assign set__callout_data

	pattern_position: INTEGER_32 assign set__pattern_position

	next_item_length: INTEGER_32 assign set__next_item_length

	mark: CE_POINTER [NATURAL_8] assign set__mark

feature {ANY} -- field setters

	set__version (a_version: INTEGER_32)
		do
			version := a_version
			update_memory_field ("version")
		end

	set__callout_number (a_callout_number: INTEGER_32)
		do
			callout_number := a_callout_number
			update_memory_field ("callout_number")
		end

	set__offset_vector (a_offset_vector: CE_POINTER [INTEGER_32])
		do
			offset_vector := a_offset_vector
			update_memory_field ("offset_vector")
		end

	set__subject (a_subject: CE_POINTER [INTEGER_8])
		do
			subject := a_subject
			update_memory_field ("subject")
		end

	set__subject_length (a_subject_length: INTEGER_32)
		do
			subject_length := a_subject_length
			update_memory_field ("subject_length")
		end

	set__start_match (a_start_match: INTEGER_32)
		do
			start_match := a_start_match
			update_memory_field ("start_match")
		end

	set__current_position (a_current_position: INTEGER_32)
		do
			current_position := a_current_position
			update_memory_field ("current_position")
		end

	set__capture_top (a_capture_top: INTEGER_32)
		do
			capture_top := a_capture_top
			update_memory_field ("capture_top")
		end

	set__capture_last (a_capture_last: INTEGER_32)
		do
			capture_last := a_capture_last
			update_memory_field ("capture_last")
		end

	set__callout_data (a_callout_data: CE_POINTER [ANY])
		do
			callout_data := a_callout_data
			update_memory_field ("callout_data")
		end

	set__pattern_position (a_pattern_position: INTEGER_32)
		do
			pattern_position := a_pattern_position
			update_memory_field ("pattern_position")
		end

	set__next_item_length (a_next_item_length: INTEGER_32)
		do
			next_item_length := a_next_item_length
			update_memory_field ("next_item_length")
		end

	set__mark (a_mark: CE_POINTER [NATURAL_8])
		do
			mark := a_mark
			update_memory_field ("mark")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			version := a_other.version
			callout_number := a_other.callout_number
			offset_vector := a_other.offset_vector
			subject := a_other.subject
			subject_length := a_other.subject_length
			start_match := a_other.start_match
			current_position := a_other.current_position
			capture_top := a_other.capture_top
			capture_last := a_other.capture_last
			callout_data := a_other.callout_data
			pattern_position := a_other.pattern_position
			next_item_length := a_other.next_item_length
			mark := a_other.mark
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				version = a_other.version and
				callout_number = a_other.callout_number and
				offset_vector.is_equal (a_other.offset_vector) and
				subject.is_equal (a_other.subject) and
				subject_length = a_other.subject_length and
				start_match = a_other.start_match and
				current_position = a_other.current_position and
				capture_top = a_other.capture_top and
				capture_last = a_other.capture_last and
				callout_data.is_equal (a_other.callout_data) and
				pattern_position = a_other.pattern_position and
				next_item_length = a_other.next_item_length and
				mark.is_equal (a_other.mark)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("version"),
					create {CE_STRUCTURE_FIELD}.make ("callout_number"),
					create {CE_STRUCTURE_FIELD}.make ("offset_vector"),
					create {CE_STRUCTURE_FIELD}.make ("subject"),
					create {CE_STRUCTURE_FIELD}.make ("subject_length"),
					create {CE_STRUCTURE_FIELD}.make ("start_match"),
					create {CE_STRUCTURE_FIELD}.make ("current_position"),
					create {CE_STRUCTURE_FIELD}.make ("capture_top"),
					create {CE_STRUCTURE_FIELD}.make ("capture_last"),
					create {CE_STRUCTURE_FIELD}.make ("callout_data"),
					create {CE_STRUCTURE_FIELD}.make ("pattern_position"),
					create {CE_STRUCTURE_FIELD}.make ("next_item_length"),
					create {CE_STRUCTURE_FIELD}.make ("mark")
				>>)
			init_structure_info
		end

end
