class
	PD_STATEBLOCK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make_initialized (a_data: TUPLE [
				a_offset: INTEGER_32
				a_count: INTEGER_32
				a_data: INTEGER_32
			])
		do
			offset := a_data.a_offset
			count := a_data.a_count
			data := a_data.a_data
		end

feature {ANY} -- fields

	offset: INTEGER_32 assign set__offset

	count: INTEGER_32 assign set__count

	data: INTEGER_32 assign set__data

feature {ANY} -- field setters

	set__offset (a_offset: INTEGER_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

	set__count (a_count: INTEGER_32)
		do
			count := a_count
			update_memory_field ("count")
		end

	set__data (a_data: INTEGER_32)
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			offset := a_other.offset
			count := a_other.count
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				offset = a_other.offset and
				count = a_other.count and
				data = a_other.data
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("offset"),
					create {CE_STRUCTURE_FIELD}.make ("count"),
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
